#include <string>
using namespace std;

const int MAX_QUEUE = 50;

template<typename T>
class QueueA {
public:
  QueueA() {
    _front = 0;
    _back = MAX_QUEUE-1;
    _count = 0;
  }

  bool isEmpty() const { return _count == 0; }
  int size() const { return _count; }

  void enqueue(const T& newItem) {
    if (_count == MAX_QUEUE)
      throw string("Queue is full");
    else {     
      _back = (_back+1) % MAX_QUEUE;
      _items[_back] = newItem;
      ++_count;
    }
  }

  void dequeue() {
    if (isEmpty())
      throw string("Queue is empty");
    else {
      _front = (_front+1) % MAX_QUEUE;
      --_count;
    }
  }

  void getFront(T& queueFront) const {
    if (isEmpty())
      throw string("Queue is empty");
    else
      queueFront = _items[_front];
  }

private:
  T _items[MAX_QUEUE];
  int _front, _back, _count;
};
