#include <string>
#include <vector>
using namespace std;

template <typename T>
class StackV {
public:
  StackV() {} // no need to do anything
  bool isEmpty() const { return _items.empty(); }
  int size() const { return _items.size(); }
  void push(const T& newItem) { _items.push_back(newItem); }

  void top(T& stackTop) const {
    if (isEmpty())
      throw string("Stack is empty on top()");
    else
      stackTop = _items.back();
  }

  void pop() {
    if (isEmpty())
      throw string("Stack is empty on pop()");
    else
      _items.pop_back();
  }

private:
  vector<T> _items;
};
